#include <GMLuaModule.h>
#include <cdll_int.h>
#include <iachievementmgr.h>

#define IACHV_NAME "IAchievement"
#define IACHV_ID 9089

GMOD_MODULE(GLoad, GUnload)

ILuaInterface *gLua = NULL;
IAchievementMgr *achvm = NULL;

LUA_FUNCTION(Count)
{
	gLua->PushDouble(achvm->GetAchievementCount());

	return 1;
}

LUA_FUNCTION(GetAll)
{
	ILuaObject *tReturn = gLua->GetNewTable();

	for (int i=1;i<=achvm->GetAchievementCount();i++)
	{
		gLua->PushUserData(gLua->GetMetaTable(IACHV_NAME, IACHV_ID), achvm->GetAchievementByIndex(i));

		tReturn->SetMember(i, gLua->GetObject());
	}

	gLua->Push(tReturn);

	tReturn->UnReference();

	return 1;
}

LUA_FUNCTION(Award)
{
	gLua->CheckType(1, IACHV_ID);

	IAchievement *achv = (IAchievement*)gLua->GetUserData(1);

	achvm->AwardAchievement(achv->GetAchievementID());

	return 0;
}

LUA_FUNCTION(Name)
{
	gLua->CheckType(1, IACHV_ID);

	IAchievement *achv = (IAchievement*)gLua->GetUserData(1);
	
	gLua->Push(achv->GetName());

	return 1;
}

LUA_FUNCTION(ID)
{
	gLua->CheckType(1, IACHV_ID);

	IAchievement *achv = (IAchievement*)gLua->GetUserData(1);
	
	gLua->PushDouble(achv->GetAchievementID());

	return 1;
}

LUA_FUNCTION(IsAchieved)
{
	gLua->CheckType(1, IACHV_ID);

	IAchievement *achv = (IAchievement*)gLua->GetUserData(1);
	
	gLua->Push(achv->IsAchieved());

	return 1;
}

int GLoad(lua_State *L)
{
	CreateInterfaceFn IEngine = Sys_GetFactory("engine.dll");
	achvm = ((IVEngineClient*)IEngine(VENGINE_CLIENT_INTERFACE_VERSION, NULL))->GetAchievementMgr();
	
	gLua = Lua();

	ILuaObject *mTable = gLua->GetMetaTable(IACHV_NAME, IACHV_ID);
		ILuaObject *__index = gLua->GetNewTable();
			__index->SetMember("Award", Award);
			__index->SetMember("Name", Name);
			__index->SetMember("ID", ID);
			__index->SetMember("IsAchieved", IsAchieved);
			
			mTable->SetMember("__index", __index);
		__index->UnReference();
	mTable->UnReference();

	gLua->NewGlobalTable("achievementx");
	
	ILuaObject *achvx = gLua->GetGlobal("achievementx");
		achvx->SetMember("Count", Count);
		achvx->SetMember("GetAll", GetAll);		
	achvx->UnReference();

	return 0;
}

int GUnload(lua_State *L)
{
	return 0;
}